function GGF.Settings.Controls()
  local fontOptions = GGF.Theme.fonts
  local textureOptions = GGF.Theme.textures
  local styleOptions = {"normal", "outline", "shadow", "soft-shadow-thick", "soft-shadow-thin", "thick-outline"}
  local formatOptions = {"Nothing", "Current", "Current + Shield", "Max", "Percentage%", "Current / Max", "Current + Shield / Max", "Current / Max (Percentage%)", "Current + Shield / Max (Percentage%)", "Current (Percentage%)", "Current + Shield (Percentage%)"}
  local formatLocations = {"Left", "Center", "Right"}
  local raidFormatTypes = GGF.Locale:Get('Setting_Raid_Layout_Opt')

  local LAM = LibStub("LibAddonMenu-1.0")
  GGF.Settings.panelID = LAM:CreateControlPanel( "ggFrameSettingMenu", "ggFrames")
  header = LAM:AddHeader( GGF.Settings.panelID, "ggFrameSettingMenuHeader", "Version |cAA0000"..GGF.version.."|r by |c00AA00@gamegenius86|r & |c003b6f@Corodius|r")

  header:SetHandler("OnShow", function() 
    ZO_OptionsWindowResetToDefaultButton:SetAlpha(0)
    ZO_OptionsWindowResetToDefaultButton:SetEnabled(false)
    ZO_OptionsWindowResetToDefaultButton:SetKeybindEnabled(false)
  end)
  header:SetHandler("OnHide", function() 
    ZO_OptionsWindowResetToDefaultButton:SetAlpha(1)
    ZO_OptionsWindowResetToDefaultButton:SetEnabled(true)
    ZO_OptionsWindowResetToDefaultButton:SetKeybindEnabled(true)
  end)

  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingFrameLock",                   GGF.Locale:Get('Frame_Lock'), nil,                               function() return not GGF.Settings.IsFrameMovable() end,                        function() GGF.Settings.ToggleFrameMovable() end )
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingGlobal',                      GGF.Locale:Get('Setting_Global') )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingDefPlayerToggle",             GGF.Locale:Get('Display_Default_Player'), nil,                   function() return GGF.Settings.GetValue('Display_Default_Player') end,          function() GGF.Settings.SetValue('Display_Default_Player', not GGF.Settings.GetValue('Display_Default_Player')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingGGPlayerToggle",              GGF.Locale:Get('Display_Player'), nil,                           function() return GGF.Settings.GetValue('Display_Player') end,                  function() GGF.Settings.SetValue('Display_Player', not GGF.Settings.GetValue('Display_Player')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingDefTargetToggle",             GGF.Locale:Get('Display_Default_Target'), nil,                   function() return GGF.Settings.GetValue('Display_Default_Target') end,          function() GGF.Settings.SetValue('Display_Default_Target', not GGF.Settings.GetValue('Display_Default_Target')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingGGTargetToggle",              GGF.Locale:Get('Display_Target'), nil,                           function() return GGF.Settings.GetValue('Display_Target') end,                  function() GGF.Settings.SetValue('Display_Target', not GGF.Settings.GetValue('Display_Target')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingDefGroupToggle",              GGF.Locale:Get('Display_Default_Group'), nil,                    function() return GGF.Settings.GetValue('Display_Default_Group') end,           function() GGF.Settings.SetValue('Display_Default_Group', not GGF.Settings.GetValue('Display_Default_Group')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingGGGroupToggle",               GGF.Locale:Get('Display_Group'), nil,                            function() return GGF.Settings.GetValue('Display_Group') end,                   function() GGF.Settings.SetValue('Display_Group', not GGF.Settings.GetValue('Display_Group')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingGGPowerRegen",                GGF.Locale:Get('Display_Power_Regens'), nil,                     function() return GGF.Settings.GetValue('Display_Power_Regens') end,            function() GGF.Settings.SetValue('Display_Power_Regens', not GGF.Settings.GetValue('Display_Power_Regens')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingGGBuffs",                     GGF.Locale:Get('Display_Buffs'), nil,                            function() return GGF.Settings.GetValue('Display_Buffs') end,                   function() GGF.Settings.SetValue('Display_Buffs', not GGF.Settings.GetValue('Display_Buffs')) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingBarFont",                     GGF.Locale:Get('Font'), nil, fontOptions,                        function() return GGF.Settings.GetValue('Font') end,                            function( val ) GGF.Settings.SetValue('Font',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingBarFontStyle",                GGF.Locale:Get('Font_Style'), nil, styleOptions,                 function() return GGF.Settings.GetValue('Font_Style') end,                      function( val ) GGF.Settings.SetValue('Font_Style',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingBarTexture",                  GGF.Locale:Get('Bar_Texture'), nil, textureOptions,              function() return GGF.Settings.GetValue('Bar_Texture') end,                     function( val ) GGF.Settings.SetValue('Bar_Texture',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingBarFormat",                   GGF.Locale:Get('Bar_Format'), nil, formatOptions,                function() return GGF.Settings.GetValue('Bar_Format') end,                      function( val ) GGF.Settings.SetValue('Bar_Format',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingBarFormatLoc",                GGF.Locale:Get('Bar_Format_Location'), nil, formatLocations,     function() return GGF.Settings.GetValue('Bar_Format_Location') end,             function( val ) GGF.Settings.SetValue('Bar_Format_Location',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingBarFormatTwo",                GGF.Locale:Get('Bar_Format_Two'), nil, formatOptions,            function() return GGF.Settings.GetValue('Bar_Format_Two') end,                  function( val ) GGF.Settings.SetValue('Bar_Format_Two',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingBarFormatLocTwo",             GGF.Locale:Get('Bar_Format_Location_Two'), nil, formatLocations, function() return GGF.Settings.GetValue('Bar_Format_Location_Two') end,         function( val ) GGF.Settings.SetValue('Bar_Format_Location_Two',val) end )
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingPlayer',                      GGF.Locale:Get('Setting_Player') )
  LAM:AddEditBox(    GGF.Settings.panelID, "ggFramesSettingPlayerPositionX",             GGF.Locale:Get('Frame_PositionX'), nil, false,                   function() return GGF.Settings.GetValue('PlayerContainer_OffsetX') end,         function( val ) GGF.Settings.SetValue('PlayerContainer_OffsetX',val) end )
  LAM:AddEditBox(    GGF.Settings.panelID, "ggFramesSettingPlayerPositionY",             GGF.Locale:Get('Frame_PositionY'), nil, false,                   function() return GGF.Settings.GetValue('PlayerContainer_OffsetY') end,         function( val ) GGF.Settings.SetValue('PlayerContainer_OffsetY',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerCombatAlpha',           GGF.Locale:Get('Combat_Alpha'), nil, 0, 100, 5,                  function() return GGF.Settings.GetValue('Player_Combat_Alpha') end,             function( val ) GGF.Settings.SetValue('Player_Combat_Alpha',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerAlpha',                 GGF.Locale:Get('Frame_Alpha'), nil, 0, 100, 5,                   function() return GGF.Settings.GetValue('Player_Alpha') end,                   function( val ) GGF.Settings.SetValue('Player_Alpha',val) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingPlayerCombatAlphaPower",      GGF.Locale:Get('Combat_Alpha_Power'), nil,                       function() return GGF.Settings.GetValue('Player_Combat_Alpha_Power') end,       function() GGF.Settings.SetValue('Player_Combat_Alpha_Power', not GGF.Settings.GetValue('Player_Combat_Alpha_Power')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingPlayerDisplay",               GGF.Locale:Get('Display_Player_Info'), nil,                      function() return GGF.Settings.GetValue('Player_Info_Display') end,             function() GGF.Settings.SetValue('Player_Info_Display', not GGF.Settings.GetValue('Player_Info_Display')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingPlayerExperienceDisplay",     GGF.Locale:Get('Display_Player_Experience'), nil,                function() return GGF.Settings.GetValue('Player_Experience_Display') end,       function() GGF.Settings.SetValue('Player_Experience_Display', not GGF.Settings.GetValue('Player_Experience_Display')) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerWidth',                 GGF.Locale:Get('Frame_Width'), nil, 200, 400, 5,                 function() return GGF.Settings.GetValue('Player_Width') end,                    function( val ) GGF.Settings.SetValue('Player_Width',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerFontSize',              GGF.Locale:Get('Info_FontSize'), nil, 10, 30, 1,                 function() return GGF.Settings.GetValue('Player_FontSize') end,                 function( val ) GGF.Settings.SetValue('Player_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerFontColor",             GGF.Locale:Get('Info_FontColor'), nil,                           function() return GGF.Settings.GetColor('Player_FontColor') end,                function( r,g,b,a ) GGF.Settings.SetColor('Player_FontColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerPadding',               GGF.Locale:Get('Player_Padding'), nil, -1, 10, 1,                function() return GGF.Settings.GetValue('Player_Padding') end,                  function( val ) GGF.Settings.SetValue('Player_Padding',val) end )
  
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingPlayerBuffs',                 GGF.Locale:Get('Setting_Player_Buffs') )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingPlayerBuffLoc",               GGF.Locale:Get('Buff_Location'), nil, GGF.Locale:Get('Placement'), function() return GGF.Settings.GetValue('Player_Buff_Location') end,         function( val ) GGF.Settings.SetValue('Player_Buff_Location',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingPlayerBuffOrderX",            GGF.Locale:Get('Buff_OrderX'), nil, GGF.Locale:Get('OrderX'), function() return GGF.Settings.GetValue('Player_Buff_OrderX') end,         function( val ) GGF.Settings.SetValue('Player_Buff_OrderX',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingPlayerBuffOrderY",            GGF.Locale:Get('Buff_OrderY'), nil, GGF.Locale:Get('OrderY'), function() return GGF.Settings.GetValue('Player_Buff_OrderY') end,         function( val ) GGF.Settings.SetValue('Player_Buff_OrderY',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingPlayerDebuffLoc",             GGF.Locale:Get('Debuff_Location'), nil, GGF.Locale:Get('Placement'), function() return GGF.Settings.GetValue('Player_Debuff_Location') end,         function( val ) GGF.Settings.SetValue('Player_Debuff_Location',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingPlayerDebuffOrderX",          GGF.Locale:Get('Debuff_OrderX'), nil, GGF.Locale:Get('OrderX'), function() return GGF.Settings.GetValue('Player_Debuff_OrderX') end,         function( val ) GGF.Settings.SetValue('Player_Debuff_OrderX',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingPlayerDebuffOrderY",          GGF.Locale:Get('Debuff_OrderY'), nil, GGF.Locale:Get('OrderY'), function() return GGF.Settings.GetValue('Player_Debuff_OrderY') end,         function( val ) GGF.Settings.SetValue('Player_Debuff_OrderY',val) end )

  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingPlayerHealth',                GGF.Locale:Get('Setting_Player_Health') )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerHealthHeight',          GGF.Locale:Get('Health_Height'), nil, 10, 60, 2,                 function() return GGF.Settings.GetValue('Player_Health_Height') end,            function( val ) GGF.Settings.SetValue('Player_Health_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerHealthColor",           GGF.Locale:Get('Health_BarColor'), nil,                          function() return GGF.Settings.GetColor('Player_Health_BarColor') end,          function( r,g,b,a ) GGF.Settings.SetColor('Player_Health_BarColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerHealthFontSize',        GGF.Locale:Get('Health_FontSize'), nil, 10, 30, 1,               function() return GGF.Settings.GetValue('Player_Health_FontSize') end,          function( val ) GGF.Settings.SetValue('Player_Health_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerHealthFontColor",       GGF.Locale:Get('Health_FontColor'), nil,                         function() return GGF.Settings.GetColor('Player_Health_FontColor') end,         function( r,g,b,a ) GGF.Settings.SetColor('Player_Health_FontColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerShieldHeight',          GGF.Locale:Get('Shield_Height'), nil, 4, 60, 2,                  function() return GGF.Settings.GetValue('Player_Shield_Height') end,            function( val ) GGF.Settings.SetValue('Player_Shield_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerShieldColor",           GGF.Locale:Get('Shield_BarColor'), nil,                          function() return GGF.Settings.GetColor('Player_Shield_BarColor') end,          function( r,g,b,a ) GGF.Settings.SetColor('Player_Shield_BarColor',r,g,b,a) end ) 
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingPlayerMagicka',               GGF.Locale:Get('Setting_Player_Magicka') )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerMagickaHeight',         GGF.Locale:Get('Magicka_Height'), nil, 10, 60, 2,                function() return GGF.Settings.GetValue('Player_Magicka_Height') end,           function( val ) GGF.Settings.SetValue('Player_Magicka_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerMagickaColor",          GGF.Locale:Get('Magicka_BarColor'), nil,                         function() return GGF.Settings.GetColor('Player_Magicka_BarColor') end,         function( r,g,b,a ) GGF.Settings.SetColor('Player_Magicka_BarColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerMagickaFontSize',       GGF.Locale:Get('Magicka_FontSize'), nil, 10, 30, 1,              function() return GGF.Settings.GetValue('Player_Magicka_FontSize') end,         function( val ) GGF.Settings.SetValue('Player_Magicka_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerMagickaFontColor",      GGF.Locale:Get('Magicka_FontColor'), nil,                        function() return GGF.Settings.GetColor('Player_Magicka_FontColor') end,        function( r,g,b,a ) GGF.Settings.SetColor('Player_Magicka_FontColor',r,g,b,a) end )
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingPlayerStamina',               GGF.Locale:Get('Setting_Player_Stamina') )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerStaminaHeight',         GGF.Locale:Get('Stamina_Height'), nil, 10, 60, 2,                function() return GGF.Settings.GetValue('Player_Stamina_Height') end,           function( val ) GGF.Settings.SetValue('Player_Stamina_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerStaminaColor",          GGF.Locale:Get('Stamina_BarColor'), nil,                         function() return GGF.Settings.GetColor('Player_Stamina_BarColor') end,         function( r,g,b,a ) GGF.Settings.SetColor('Player_Stamina_BarColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerStaminaFontSize',       GGF.Locale:Get('Stamina_FontSize'), nil, 10, 30, 1,              function() return GGF.Settings.GetValue('Player_Stamina_FontSize') end,         function( val ) GGF.Settings.SetValue('Player_Stamina_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerStaminaFontColor",      GGF.Locale:Get('Stamina_FontColor'), nil,                        function() return GGF.Settings.GetColor('Player_Stamina_FontColor') end,        function( r,g,b,a ) GGF.Settings.SetColor('Player_Stamina_FontColor',r,g,b,a) end )
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingPlayerExperience',            GGF.Locale:Get('Setting_Player_Experience') )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerExperienceHeight',      GGF.Locale:Get('Experience_Height'), nil, 6, 30, 2,              function() return GGF.Settings.GetValue('Player_Experience_Height') end,        function( val ) GGF.Settings.SetValue('Player_Experience_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerExperienceColor",       GGF.Locale:Get('Experience_BarColor'), nil,                      function() return GGF.Settings.GetColor('Player_Experience_BarColor') end,      function( r,g,b,a ) GGF.Settings.SetColor('Player_Experience_BarColor',r,g,b,a) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingPlayerExperienceTextDisplay", GGF.Locale:Get('Experience_Text_Display'), nil,                  function() return GGF.Settings.GetValue('Player_Experience_Text_Display') end,  function() GGF.Settings.SetValue('Player_Experience_Text_Display', not GGF.Settings.GetValue('Player_Experience_Text_Display')) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerExperienceFontSize',    GGF.Locale:Get('Experience_FontSize'), nil, 10, 30, 1,           function() return GGF.Settings.GetValue('Player_Experience_FontSize') end,      function( val ) GGF.Settings.SetValue('Player_Experience_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerExperienceFontColor",   GGF.Locale:Get('Experience_FontColor'), nil,                     function() return GGF.Settings.GetColor('Player_Experience_FontColor') end,     function( r,g,b,a ) GGF.Settings.SetColor('Player_Experience_FontColor',r,g,b,a) end )
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingPlayerMount',                 GGF.Locale:Get('Setting_Player_Mount') )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingPlayerMountSeperated",        GGF.Locale:Get('Mount_Seperated'), nil,                          function() return GGF.Settings.GetValue('Player_Mount_Seperated') end,          function() GGF.Settings.SetValue('Player_Mount_Seperated', not GGF.Settings.GetValue('Player_Mount_Seperated')) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingPlayerMountHeight',           GGF.Locale:Get('Mount_Height'), nil, 6, 30, 2,                   function() return GGF.Settings.GetValue('Player_Mount_Height') end,             function( val ) GGF.Settings.SetValue('Player_Mount_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingPlayerMountColor",            GGF.Locale:Get('Mount_BarColor'), nil,                           function() return GGF.Settings.GetColor('Player_Mount_BarColor') end,           function( r,g,b,a ) GGF.Settings.SetColor('Player_Mount_BarColor',r,g,b,a) end )
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingGroup',                       GGF.Locale:Get('Setting_Group') )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingGroupCondensed",              GGF.Locale:Get('Group_Condensed'), nil,                          function() return GGF.Settings.GetValue('Group_Condensed') end,                 function() GGF.Settings.SetValue('Group_Condensed', not GGF.Settings.GetValue('Group_Condensed')) end )
  LAM:AddCheckbox(   GGF.Settings.panelID, "ggFramesSettingGroupIncludePlayer",          GGF.Locale:Get('Group_Include_Player'), nil,                     function() return GGF.Settings.GetValue('Group_Include_Player') end,            function() GGF.Settings.SetValue('Group_Include_Player', not GGF.Settings.GetValue('Group_Include_Player')) end )
  LAM:AddEditBox(    GGF.Settings.panelID, "ggFramesSettingGroupPositionX",              GGF.Locale:Get('Frame_PositionX'), nil, false,                   function() return GGF.Settings.GetValue('GroupContainer_OffsetX') end,          function( val ) GGF.Settings.SetValue('GroupContainer_OffsetX',val) end )
  LAM:AddEditBox(    GGF.Settings.panelID, "ggFramesSettingGroupPositionY",              GGF.Locale:Get('Frame_PositionY'), nil, false,                   function() return GGF.Settings.GetValue('GroupContainer_OffsetY') end,          function( val ) GGF.Settings.SetValue('GroupContainer_OffsetY',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingGroupAlpha',                  GGF.Locale:Get('Frame_Alpha'), nil, 0, 100, 5,                   function() return GGF.Settings.GetValue('GroupContainer_Alpha') end,            function( val ) GGF.Settings.SetValue('GroupContainer_Alpha',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingGroupWidth',                  GGF.Locale:Get('Frame_Width'), nil, 200, 400, 5,                 function() return GGF.Settings.GetValue('Group_Width') end,                     function( val ) GGF.Settings.SetValue('Group_Width',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingGroupFontSize',               GGF.Locale:Get('Info_FontSize'), nil, 10, 30, 1,                 function() return GGF.Settings.GetValue('Group_FontSize') end,                  function( val ) GGF.Settings.SetValue('Group_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingGroupFontColor",              GGF.Locale:Get('Info_FontColor'), nil,                           function() return GGF.Settings.GetColor('Group_FontColor') end,                 function( r,g,b,a ) GGF.Settings.SetColor('Group_FontColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingGroupHealthHeight',           GGF.Locale:Get('Health_Height'), nil, 10, 60, 2,                 function() return GGF.Settings.GetValue('Group_Health_Height') end,             function( val ) GGF.Settings.SetValue('Group_Health_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingGroupHealthColor",            GGF.Locale:Get('Health_BarColor'), nil,                          function() return GGF.Settings.GetColor('Group_Health_BarColor') end,           function( r,g,b,a ) GGF.Settings.SetColor('Group_Health_BarColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingGroupHealthFontSize',         GGF.Locale:Get('Health_FontSize'), nil, 10, 30, 1,               function() return GGF.Settings.GetValue('Group_Health_FontSize') end,           function( val ) GGF.Settings.SetValue('Group_Health_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingGroupHealthFontColor",        GGF.Locale:Get('Health_FontColor'), nil,                         function() return GGF.Settings.GetColor('Group_Health_FontColor') end,          function( r,g,b,a ) GGF.Settings.SetColor('Group_Health_FontColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingGroupShieldHeight',           GGF.Locale:Get('Shield_Height'), nil, 4, 60, 2,                  function() return GGF.Settings.GetValue('Group_Shield_Height') end,             function( val ) GGF.Settings.SetValue('Group_Shield_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingGroupShieldColor",            GGF.Locale:Get('Shield_BarColor'), nil,                          function() return GGF.Settings.GetColor('Group_Shield_BarColor') end,           function( r,g,b,a ) GGF.Settings.SetColor('Group_Shield_BarColor',r,g,b,a) end ) 
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingLargeGroup',                  GGF.Locale:Get('Setting_Raid') )
  LAM:AddSlider(     GGF.Settings.panelID, "ggFramesSettingBarRaidLayout",               GGF.Locale:Get('Setting_Raid_Layout'), nil, 2, 24, 1,            function() return GGF.Settings.GetValue('LargeGroup_Units_Per_Column') end,     function( val ) GGF.Settings.SetValue('LargeGroup_Units_Per_Column',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, "ggFramesSettingBarRaidPadding",              GGF.Locale:Get('Setting_Raid_Padding'), nil, -1, 10, 1,          function() return GGF.Settings.GetValue('LargeGroup_Padding') end,              function( val ) GGF.Settings.SetValue('LargeGroup_Padding',val) end )
  LAM:AddEditBox(    GGF.Settings.panelID, "ggFramesSettingLargeGroupPositionX",         GGF.Locale:Get('Frame_PositionX'), nil, false,                   function() return GGF.Settings.GetValue('LargeGroupContainer_OffsetX') end,     function( val ) GGF.Settings.SetValue('LargeGroupContainer_OffsetX',val) end )
  LAM:AddEditBox(    GGF.Settings.panelID, "ggFramesSettingLargeGroupPositionY",         GGF.Locale:Get('Frame_PositionY'), nil, false,                   function() return GGF.Settings.GetValue('LargeGroupContainer_OffsetY') end,     function( val ) GGF.Settings.SetValue('LargeGroupContainer_OffsetY',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingLargeGroupAlpha',             GGF.Locale:Get('Frame_Alpha'), nil, 0, 100, 5,                   function() return GGF.Settings.GetValue('LargeGroupContainer_Alpha') end,       function( val ) GGF.Settings.SetValue('LargeGroupContainer_Alpha',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingLargeGroupWidth',             GGF.Locale:Get('Frame_Width'), nil, 100, 250, 5,                 function() return GGF.Settings.GetValue('LargeGroup_Width') end,                function( val ) GGF.Settings.SetValue('LargeGroup_Width',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingLargeGroupHeight',            GGF.Locale:Get('Frame_Height'), nil, 24, 100, 2,                 function() return GGF.Settings.GetValue('LargeGroup_Height') end,               function( val ) GGF.Settings.SetValue('LargeGroup_Height',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingLargeGroupFontSize',          GGF.Locale:Get('Info_FontSize'), nil, 10, 30, 1,                 function() return GGF.Settings.GetValue('LargeGroup_FontSize') end,             function( val ) GGF.Settings.SetValue('LargeGroup_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingLargeGroupFontColor",         GGF.Locale:Get('Info_FontColor'), nil,                           function() return GGF.Settings.GetColor('LargeGroup_FontColor') end,            function( r,g,b,a ) GGF.Settings.SetColor('LargeGroup_FontColor',r,g,b,a) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingLargeGroupHealthColor",       GGF.Locale:Get('Health_BarColor'), nil,                          function() return GGF.Settings.GetColor('LargeGroup_Health_BarColor') end,      function( r,g,b,a ) GGF.Settings.SetColor('LargeGroup_Health_BarColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingLargeGroupShieldHeight',      GGF.Locale:Get('Shield_Height'), nil, 4, 60, 2,                  function() return GGF.Settings.GetValue('LargeGroup_Shield_Height') end,        function( val ) GGF.Settings.SetValue('LargeGroup_Shield_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingLargeGroupShieldColor",       GGF.Locale:Get('Shield_BarColor'), nil,                          function() return GGF.Settings.GetColor('LargeGroup_Shield_BarColor') end,      function( r,g,b,a ) GGF.Settings.SetColor('LargeGroup_Shield_BarColor',r,g,b,a) end ) 
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingTarget',                      GGF.Locale:Get('Setting_Target') )
  LAM:AddEditBox(    GGF.Settings.panelID, "ggFramesSettingTargetPositionX",             GGF.Locale:Get('Frame_PositionX'), nil, false,                   function() return GGF.Settings.GetValue('TargetContainer_OffsetX') end,         function( val ) GGF.Settings.SetValue('TargetContainer_OffsetX',val) end )
  LAM:AddEditBox(    GGF.Settings.panelID, "ggFramesSettingTargetPositionY",             GGF.Locale:Get('Frame_PositionY'), nil, false,                   function() return GGF.Settings.GetValue('TargetContainer_OffsetY') end,         function( val ) GGF.Settings.SetValue('TargetContainer_OffsetY',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingTargetCombatAlpha',           GGF.Locale:Get('Combat_Alpha'), nil, 0, 100, 5,                  function() return GGF.Settings.GetValue('Target_Combat_Alpha') end,             function( val ) GGF.Settings.SetValue('Target_Combat_Alpha',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingTargetAlpha',                 GGF.Locale:Get('Frame_Alpha'), nil, 0, 100, 5,                   function() return GGF.Settings.GetValue('Target_Alpha') end,                    function( val ) GGF.Settings.SetValue('Target_Alpha',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingTargetWidth',                 GGF.Locale:Get('Frame_Width'), nil, 200, 400, 5,                 function() return GGF.Settings.GetValue('Target_Width') end,                    function( val ) GGF.Settings.SetValue('Target_Width',val) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingTargetFontSize',              GGF.Locale:Get('Info_FontSize'), nil, 10, 30, 1,                 function() return GGF.Settings.GetValue('Target_FontSize') end,                 function( val ) GGF.Settings.SetValue('Target_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingTargetFontColor",             GGF.Locale:Get('Info_FontColor'), nil,                           function() return GGF.Settings.GetColor('Target_FontColor') end,                function( r,g,b,a ) GGF.Settings.SetColor('Target_FontColor',r,g,b,a) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingTargetFontColor_Friendly",    GGF.Locale:Get('Target_FontColor_Friendly'), nil,                function() return GGF.Settings.GetColor('Target_FontColor_Friendly') end,       function( r,g,b,a ) GGF.Settings.SetColor('Target_FontColor_Friendly',r,g,b,a) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingTargetFontColor_Hostile",     GGF.Locale:Get('Target_FontColor_Hostile'), nil,                 function() return GGF.Settings.GetColor('Target_FontColor_Hostile') end,        function( r,g,b,a ) GGF.Settings.SetColor('Target_FontColor_Hostile',r,g,b,a) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingTargetFontColor_Interact",    GGF.Locale:Get('Target_FontColor_Interact'), nil,                function() return GGF.Settings.GetColor('Target_FontColor_Interact') end,       function( r,g,b,a ) GGF.Settings.SetColor('Target_FontColor_Interact',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingTargetHealthHeight',          GGF.Locale:Get('Health_Height'), nil, 10, 60, 2,                 function() return GGF.Settings.GetValue('Target_Health_Height') end,            function( val ) GGF.Settings.SetValue('Target_Health_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingTargetHealthColor",           GGF.Locale:Get('Health_BarColor'), nil,                          function() return GGF.Settings.GetColor('Target_Health_BarColor') end,          function( r,g,b,a ) GGF.Settings.SetColor('Target_Health_BarColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingTargetHealthFontSize',        GGF.Locale:Get('Health_FontSize'), nil, 10, 30, 1,               function() return GGF.Settings.GetValue('Target_Health_FontSize') end,          function( val ) GGF.Settings.SetValue('Target_Health_FontSize',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingTargetHealthFontColor",       GGF.Locale:Get('Health_FontColor'), nil,                         function() return GGF.Settings.GetColor('Target_Health_FontColor') end,         function( r,g,b,a ) GGF.Settings.SetColor('Target_Health_FontColor',r,g,b,a) end )
  LAM:AddSlider(     GGF.Settings.panelID, 'ggFramesSettingTargetShieldHeight',          GGF.Locale:Get('Shield_Height'), nil, 4, 60, 2,                  function() return GGF.Settings.GetValue('Target_Shield_Height') end,            function( val ) GGF.Settings.SetValue('Target_Shield_Height',val) end )
  LAM:AddColorPicker(GGF.Settings.panelID, "ggFramesSettingTargetShieldColor",           GGF.Locale:Get('Shield_BarColor'), nil,                          function() return GGF.Settings.GetColor('Target_Shield_BarColor') end,          function( r,g,b,a ) GGF.Settings.SetColor('Target_Shield_BarColor',r,g,b,a) end ) 
    
  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingTargetBuffs',                 GGF.Locale:Get('Setting_Target_Buffs') )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingTargetBuffLoc",               GGF.Locale:Get('Buff_Location'), nil, GGF.Locale:Get('Placement'), function() return GGF.Settings.GetValue('Target_Buff_Location') end,         function( val ) GGF.Settings.SetValue('Target_Buff_Location',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingTargetBuffOrderX",            GGF.Locale:Get('Buff_OrderX'), nil, GGF.Locale:Get('OrderX'), function() return GGF.Settings.GetValue('Target_Buff_OrderX') end,         function( val ) GGF.Settings.SetValue('Target_Buff_OrderX',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingTargetBuffOrderY",            GGF.Locale:Get('Buff_OrderY'), nil, GGF.Locale:Get('OrderY'), function() return GGF.Settings.GetValue('Target_Buff_OrderY') end,         function( val ) GGF.Settings.SetValue('Target_Buff_OrderY',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingTargetDebuffLoc",             GGF.Locale:Get('Debuff_Location'), nil, GGF.Locale:Get('Placement'), function() return GGF.Settings.GetValue('Target_Debuff_Location') end,         function( val ) GGF.Settings.SetValue('Target_Debuff_Location',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingTargetDebuffOrderX",          GGF.Locale:Get('Debuff_OrderX'), nil, GGF.Locale:Get('OrderX'), function() return GGF.Settings.GetValue('Target_Debuff_OrderX') end,         function( val ) GGF.Settings.SetValue('Target_Debuff_OrderX',val) end )
  LAM:AddDropdown(   GGF.Settings.panelID, "ggFramesSettingTargetDebuffOrderY",          GGF.Locale:Get('Debuff_OrderY'), nil, GGF.Locale:Get('OrderY'), function() return GGF.Settings.GetValue('Target_Debuff_OrderY') end,         function( val ) GGF.Settings.SetValue('Target_Debuff_OrderY',val) end )

  LAM:AddHeader(     GGF.Settings.panelID, 'ggFramesSettingResetSection',                GGF.Locale:Get('Setting_Defaults') )
  LAM:AddDescription(GGF.Settings.panelID, 'ggFramesSettingResetDescription',            GGF.Locale:Get('Setting_Reset_Warning'))  
  LAM:AddButton(     GGF.Settings.panelID, "ggFramesSettingResetButton",                 GGF.Locale:Get('Setting_Reset_Button'), nil,                    function() GGF.Settings.ResetDefaults() end)
end